package com.ruoyi.web.sspManage.service;

import com.alibaba.fastjson.JSONArray;
import com.ruoyi.common.config.RuoYiConfig;
import com.ruoyi.common.core.text.Convert;
import com.ruoyi.common.enums.SysRoleEnum;
import com.ruoyi.common.utils.QiniuBase64UploadUtil;
import com.ruoyi.common.utils.file.FileUploadUtils;
import com.ruoyi.system.mapper.SysDeptMapper;
import com.ruoyi.system.mapper.SysRoleMapper;
import com.ruoyi.web.projectInfo.mapper.WxProjectInfoMapper;
import com.ruoyi.web.sspManage.mapper.SspMapper;
import com.ruoyi.web.sspMarks.domain.ProcessName;
import com.ruoyi.web.userLogin.mapper.WxUserLoginMapper;
import com.ruoyi.web.utils.MultipartFileUtils;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.multipart.MultipartFile;

import java.util.*;

/**
 * @ClassName:ISspServiceImpl
 * @Description:TODO
 * @Author:
 * @Date:2021/3/30 17:04
 * @version:V1.0
 */
@Service
public class SspServiceImpl implements ISspService {

    @Autowired
    private SspMapper sspMapper;

    @Autowired
    private WxUserLoginMapper wxUserLoginMapper;

    @Autowired
    private SysRoleMapper sysRoleMapper;

    @Autowired
    private SysDeptMapper sysDeptMapper;

    @Autowired
    private WxProjectInfoMapper wxProjectInfoMapper;

    /**
     * @describe:查询随手拍信息的列表(问题整改)
     * @author:
     * @date:2021/3/30&15:25
     * @version:V1.0
     * @param:
     * @return:
     * @Exception:
     */
    @Override
    public Map<String, Object> listSspInfoChanges(Map<String, Object> map) {
        //返回
        Map<String, Object> resultMap = new HashMap<>();
        /**
         * 根据获取的用户信息和项目id进行判断是抄送还是主送
         * showState
         * 主送状态0
         * 抄送状态1
         * */
        String thisUser = map.get("loginName").toString();
        String projectName = "";
        //查询问题整改数据(发布记录)
        List<Map<String, Object>> allChangesInfo = sspMapper.listSspInfoChanges(map);
        if(allChangesInfo != null && allChangesInfo.size() > 0) {
            //循环数据，判断加主送抄送状态
            for (int i = 0; i < allChangesInfo.size(); i++) {
                Map<String, Object> infoMap = allChangesInfo.get(i);
                //主送人
                String lordSendUser = infoMap.get("lordSentUser").toString();
                if(thisUser.equals(lordSendUser)) {
                    //待办的
                    infoMap.put("showState","0");
                } else {
                    //抄送的
                    infoMap.put("showState","1");
                }
                projectName = infoMap.get("projectName").toString();
            }
        }
        //查询问题整改数据(我的发布)
        //(0问题整改, 1质量留痕)

        /**
         * 如果没有选择默认是问题整改
         */
        if(StringUtils.isBlank(map.get("infoType").toString())) {
            map.put("infoType", "0");
        }
        List<Map<String, Object>> allNickedInfo = sspMapper.listSspInfoMyNicked(map);
        if(allNickedInfo != null && allNickedInfo.size() > 0) {
            //循环数据，判断加主送抄送状态
            for (int i = 0; i < allNickedInfo.size(); i++) {
                Map<String, Object> infoMap = allNickedInfo.get(i);
                String lordSendUser = infoMap.get("lordSentUser").toString();
                if(thisUser.equals(lordSendUser)) {
                    //待办理
                    infoMap.put("showState","0");
                } else {
                    //抄送的
                    infoMap.put("showState","1");
                }
            }
        }
        //工程名称
        resultMap.put("projectName", projectName);
        //发布记录
        resultMap.put("allChangesInfo", allChangesInfo);
        //我的发布
        resultMap.put("allNickedInfo", allNickedInfo);
        //发布记录数量
        resultMap.put("allChangesInfoSize", allChangesInfo != null?allChangesInfo.size():0);
        //我的发布数量
        resultMap.put("allNickedInfoSize", allNickedInfo != null?allNickedInfo.size():0);
        return resultMap;
    }

    /**
     * @describe:查询随手拍信息的列表(留痕上报[问题整改我发起的])
     * @author:
     * @date:2021/3/30&15:25
     * @version:V1.0
     * @param:
     * @return:
     * @Exception:
     */
    @Override
    @Transactional
    public Object listSspInfoNicked(Map<String, Object> map) {
        String result = "NO";
        //根据infoTy判断是问题整改或者是留痕上报
        //String infoType = map.get("infoType").toString();
        if(true) {
            Map<String, Object> updateMap = new HashMap<>();
            //问题整改
            Map<String, Object> dataMap = new HashMap<>();
            dataMap.put("loginName",map.get("createUser"));
            Map<String,Object> userMap =  wxUserLoginMapper.checkLoginNameAndPsw(dataMap);
            //当前登录账号角色信息
            String nowRole = Convert.toStr(sysRoleMapper.getUserMinRoleId(Convert.toLong(userMap.get("user_id"))));
            //当前角色时管理员时，修改角色为集团公司
            if(Convert.toInt(SysRoleEnum.JTGS.getCode())<Convert.toInt(nowRole)){
                nowRole = SysRoleEnum.JTGS.getCode();
            }
            map.put("roleType",nowRole);
            /**
             * 基本信息入库
             * 图片 视频入库
             * 添加对应的审批流
             * */
            //基本信息
            int a = sspMapper.saveSspInfoChanges(map);
            //审批流创建
            map.put("mainId", map.get("id"));
            map.put("processState", "1");
            updateMap.put("id",map.get("id"));
            int b = sspMapper.saveSspAuditInfo(map);
            //图片
            int c = 0;
            JSONArray JSONArray = com.alibaba.fastjson.JSONArray.parseArray(map.get("imgSrc").toString());
            String smarkUrl="";
            for (int i = 0; i < JSONArray.size(); i++) {
                //String name = "sspImg-"+ UUID.randomUUID()+".jpg";
                String objImg64 = JSONArray.get(i).toString();
                //String imgBase64One = objImg64.substring(0, objImg64.indexOf(","));
                //String imgBase64 = objImg64.substring(imgBase64One.length()+1, objImg64.length());
                Map<String, Object> imgMap = new HashMap<>();
                try {
                    MultipartFile file = MultipartFileUtils.base64ToMultipartFile(objImg64);
                    // 上传文件路径
                    String filePath = RuoYiConfig.getUploadPath();
                    // 上传并返回新文件名称
                    String fileName = FileUploadUtils.upload(filePath, file);
                    //imgMap = new QiniuBase64UploadUtil().put64image(imgBase64, name);
                    smarkUrl+=","+fileName;
                    imgMap.put("fileUrl", fileName);
                } catch (Exception e) {
                    e.printStackTrace();
                }
                imgMap.put("auditId", map.get("auditId"));
                imgMap.put("fileType", "0");
                //imgMap.put("fileUrl", imgMap.get("url"));
                imgMap.put("createUser", map.get("createUser"));
                c = sspMapper.saveSspFileInfo(imgMap);
            }
            //视频
            if(!"".equals(map.get("videoUrl").toString())) {
                Map<String, Object> fileArgsMap = new HashMap<>(16);
                fileArgsMap.put("auditId", map.get("auditId"));
                fileArgsMap.put("createUser", map.get("createUser"));
                fileArgsMap.put("fileType", "1");
                fileArgsMap.put("fileUrl", map.get("videoUrl"));
                sspMapper.saveSspFileInfo(fileArgsMap);
            }
            smarkUrl = smarkUrl.substring(1);
            updateMap.put("marksPicture",smarkUrl.split(",")[0]);
            updateMap.put("smarkUrl",smarkUrl);
            sspMapper.updateSmzSspProblemmodify(updateMap);
            if(a > 0 && b > 0 && c > 0) {
                result = "OK";
            }
        } else {

        }
        return result;
    }

    @Override
    public Map<String, Object> queryChangeNicked(Map<String, Object> map) {
        //基本信息
        Map<String, Object> ChangeNickedInfo = sspMapper.queryChangeNickedInfo(map);
        //获取流程的id,请求相关的文件信息
        map.put("auditId",ChangeNickedInfo.get("checkId"));
        map.put("fileType","0");
        //图片
        List<Map<String, Object>> fileListImg = sspMapper.listChangeNickedFile(map);
        if(fileListImg != null && fileListImg.size() > 0) {
            ChangeNickedInfo.put("fileListImgState", "OK");
            ChangeNickedInfo.put("fileListImg", fileListImg);
        } else {
            ChangeNickedInfo.put("fileListImgState", "NO");
            ChangeNickedInfo.put("fileListImg", new ArrayList<>());
        }
        //视频
        //map.put("fileType","1");
        //List<Map<String, Object>> fileListVideo = sspMapper.listChangeNickedFile(map);
        //if(fileListVideo != null && fileListVideo.size() > 0) {
        //    ChangeNickedInfo.put("fileListVideoState", "OK");
        //    ChangeNickedInfo.put("fileListVideo", fileListVideo);
        //} else {
        ChangeNickedInfo.put("fileListVideoState", "NO");
        //}
        //审核流程的信息 查询状态为0的信息 基本信息和文件信息 当前审批流是否存在驳回
        Map<String, Object> opinionMap;
        if("2".equals(map.get("numState").toString()) || "3".equals(map.get("numState").toString())) {
            opinionMap = sspMapper.queryOpinionChange(map);
        } else {
            opinionMap = sspMapper.queryOpinion(map);
        }
        ChangeNickedInfo.put("opinion", opinionMap.get("opinion")==null?"":opinionMap.get("opinion"));
        ChangeNickedInfo.put("opinionCreateTime", opinionMap.get("opinionCreateTime"));

        /*****************************************************驳回判断**************************************************/
        //当前审核信息状态
        Map<String, Object> auditInfoMap = sspMapper.queryAuditInfo(map);
        //是否有驳回
        String rejectInfo = sspMapper.queryRejectInfo(map);
        if(("0".equals(auditInfoMap.get("processState")) ||  !auditInfoMap.containsKey("processState"))  && rejectInfo == null) {
            //初始审核状态
            List<Map<String, Object>> opinionFileUrl = sspMapper.listOpinionFile(map);
            if(opinionFileUrl != null && opinionFileUrl.size() > 0) {
                ChangeNickedInfo.put("opinionFileUrlState", "OK");
                ChangeNickedInfo.put("opinionFileUrl", opinionFileUrl);
                ChangeNickedInfo.put("rejectState", "NO");
            } else {
                ChangeNickedInfo.put("opinionFileUrlState", "NO");
                ChangeNickedInfo.put("rejectState", "NO");
            }
        } else if("0".equals(auditInfoMap.get("processState")) && rejectInfo != null) {
            //被驳回的状态 以N次提交
            map.put("id", auditInfoMap.get("id"));
            List<Map<String, Object>> opinionFileUrl = sspMapper.listRejectFile(map);
            if(opinionFileUrl != null && opinionFileUrl.size() > 0) {
                ChangeNickedInfo.put("opinionFileUrlState", "OK");
                ChangeNickedInfo.put("opinionFileUrl", opinionFileUrl);
                ChangeNickedInfo.put("rejectState", "OK");
                ChangeNickedInfo.put("rejectInfo", rejectInfo);
            } else {
                ChangeNickedInfo.put("opinionFileUrlState", "NO");
                ChangeNickedInfo.put("rejectState", "OK");
                ChangeNickedInfo.put("rejectInfo", rejectInfo);
            }
        } else if("2".equals(auditInfoMap.get("processState")) && rejectInfo != null) {
            //被驳回且没有再次上传
            ChangeNickedInfo.put("opinionFileUrlState", "NO");
            ChangeNickedInfo.put("rejectState", "OK");
            ChangeNickedInfo.put("rejectInfo", rejectInfo);
        }else{
            ChangeNickedInfo.put("rejectState", "NO");
            ChangeNickedInfo.put("opinionFileUrlState", "NO");
        }

        /**************************************************************************************************************/
        if(map.get("loginUser").equals(ChangeNickedInfo.get("recheckSendUser"))) {
            ChangeNickedInfo.put("checkUserState", "OK");
        } else {
            ChangeNickedInfo.put("checkUserState", "NO");
        }
        ChangeNickedInfo.put("numState", map.get("numState"));
        return ChangeNickedInfo;
    }

    /**
     * @describe:新增问题整改主表信息
     * @author:
     * @date:2021/3/31&9:22
     * @version:V1.0
     * @param:
     * @return:
     * @Exception:
     */
    @Override
    public String saveSspInfoChanges(Map<String, Object> map) {
        //修改信息表的状态
        map.put("tableName", "smz_ssp_problemmodify");
        map.put("fieldName", "checkState");
        map.put("checkState", "1");
        map.put("keySet", "id");
        int a = sspMapper.updateState(map);
        //审批信息入库
        map.put("mainId", map.get("id"));
        map.put("opinion", map.get("opinion"));
        map.put("processState", "0");
        int b = sspMapper.saveSspAuditInfo(map);
        int c = 0;
        //图片入库
        JSONArray JSONArray = com.alibaba.fastjson.JSONArray.parseArray(map.get("imgSrc").toString());
        for (int i = 0; i < JSONArray.size(); i++) {
            String name = "sspImg-"+ UUID.randomUUID()+".jpg";
            String objImg64 = JSONArray.get(i).toString();
            String imgBase64One = objImg64.substring(0, objImg64.indexOf(","));
            String imgBase64 = objImg64.substring(imgBase64One.length()+1, objImg64.length());
            Map<String, Object> imgMap = new HashMap<>();
            try {
                MultipartFile file = MultipartFileUtils.base64ToMultipartFile(objImg64);
                // 上传文件路径
                String filePath = RuoYiConfig.getUploadPath();
                // 上传并返回新文件名称
                String fileName = FileUploadUtils.upload(filePath, file);
                //imgMap = new QiniuBase64UploadUtil().put64image(imgBase64, name);
                imgMap.put("fileUrl", fileName);
            } catch (Exception e) {
                e.printStackTrace();
            }
            imgMap.put("auditId", map.get("auditId"));
            imgMap.put("fileType", "0");
            //imgMap.put("fileUrl",imgMap.get("url"));
            imgMap.put("createUser", map.get("createUser"));
            c = sspMapper.saveSspFileInfo(imgMap);
        }
        if(a > 0 && b > 0 && c > 0) {
            return "OK";
        }
        return "NO";
    }

    /**
     * @describe:查询人员的信息
     * @author:
     * @date:2021/4/6&17:26
     * @version:V1.0
     * @param:
     * @return:
     * @Exception:
     */
    @Override
    public List<Map<String, Object>> queryUserInfo(Map<String, Object> map) {
        String nowRole = Convert.toStr(sysRoleMapper.getUserMinRoleIdByLoginName(Convert.toStr(map.get("loginName"))));
        //查询出公司信息
        List<Map<String, Object>> comList = sspMapper.selectComByProjectId(Convert.toStr(map.get("projectId")));
        Map<String, Object> userdata = new HashMap<>();
        userdata.put("projectId",Convert.toLong(map.get("projectId")));
        userdata.put("name",map.get("name"));
        userdata.put("loginName",map.get("loginName"));
        if(SysRoleEnum.ADMIN.getCode().equals(nowRole) || SysRoleEnum.SUPR.getCode().equals(nowRole) || SysRoleEnum.JTGS.getCode().equals(nowRole) || SysRoleEnum.ZGS.getCode().equals(nowRole)){
            userdata.put("roleId",SysRoleEnum.ZGS.getCode());
            //查询所属项目部门信息
            Map<String, Object> sysDept = wxProjectInfoMapper.selectDeptByProjectId(Convert.toLong(map.get("projectId")));
            userdata.put("deptId",Convert.toStr(sysDept.get("id")));
        }else if(SysRoleEnum.JLDW.getCode().equals(nowRole)){
            //监理单位只能选择监理单位
            userdata.put("roleId",SysRoleEnum.JLDW.getCode());
            //查询部门信息
            Map<String, Object> sysDept = wxProjectInfoMapper.selectDeptByUserName(Convert.toStr(map.get("loginName")));
            userdata.put("deptId",Convert.toStr(sysDept.get("id")));
        }else if(SysRoleEnum.ZBDW.getCode().equals(nowRole)){
            //总包单位只能选择总包单位
            userdata.put("roleId",SysRoleEnum.ZBDW.getCode());
            //查询部门信息
            Map<String, Object> sysDept = wxProjectInfoMapper.selectDeptByUserName(Convert.toStr(map.get("loginName")));
            userdata.put("deptId",Convert.toStr(sysDept.get("id")));
        }else if(SysRoleEnum.FBDW.getCode().equals(nowRole)){
            //分包单位只能选择分包单位
            userdata.put("roleId",SysRoleEnum.FBDW.getCode());
            //查询部门信息
            Map<String, Object> sysDept = wxProjectInfoMapper.selectDeptByUserName(Convert.toStr(map.get("loginName")));
            userdata.put("deptId",Convert.toStr(sysDept.get("id")));
        }
        //查询相关人员
        List<Map<String, Object>> userList = null;
        if(SysRoleEnum.COMMON.getCode().equals(nowRole)){
            userList = sspMapper.selectProjectUser(userdata);
        }else{
            userList = sspMapper.selectAllProjectUser(userdata);
        }
        for(Map<String, Object> comMap:comList){
            List<Map<String, Object>> userInfoList = new ArrayList<>();
            for(Map<String, Object> userMap:userList){
                //同一部门组装数据
                if(comMap.get("id").toString().equals(userMap.get("deptId").toString())){
                    userInfoList.add(userMap);
                }else if("1".equals(comMap.get("unitType").toString()) && SysRoleEnum.ZGS.getCode().equals(userMap.get("role_id").toString())){
                    userInfoList.add(userMap);
                }
            }
            comMap.put("people",userInfoList);
        }
        return comList;
    }

    @Override
    public Map<String, Object> queryUserInfo(String loginName) {
        return sspMapper.queryUserInfo(loginName);
    }

    @Override
    public List<Map<String, Object>> queryUserList(Map<String, Object> map) {
        List<Map<String, Object>> resultList = new ArrayList<>();
        Map<String,Object> user = new HashMap<>();
        List<Map<String, Object>> userList = sspMapper.queryUserList(map);
        if(userList != null && userList.size() > 0){
            user.put("people",userList);
        }
        resultList.add(user);
        return resultList;
    }

    /**
     * @describe:修改审核流程的状态
     * @author:
     * @date:2021/4/7&11:39
     * @version:V1.0
     * @param:
     * @return:
     * @Exception:
     */
    @Override
    public Object updateState(Map<String, Object> map) {
        /**
         * 根据状态修改
         * 4通过
         * 3为驳回
         * */
        int code = 0;
        int codeA = 0;
        if("4".equals(map.get("checkState").toString())) {
            //通过 修改主表状态 为通过
            map.put("tableName", "smz_ssp_problemmodify");
            map.put("fieldName", "checkState");
            map.put("checkState", map.get("checkState"));
            map.put("keySet", "id");
            code = sspMapper.updateState(map);
            //添加通过意见
            Map<String, Object> rejectMap = new HashMap<>(16);
            rejectMap.put("mainId", map.get("id"));
            rejectMap.put("opinion", map.get("opinion"));
            rejectMap.put("createUser", map.get("createUser"));
            codeA = sspMapper.saveSspAuditInfoPass(rejectMap);
        } else {
            //驳回 修改主表状态 待整改 添加审核流程驳回意见
            map.put("tableName", "smz_ssp_problemmodify");
            map.put("fieldName", "checkState");
            map.put("checkState", "0");
            map.put("keySet", "id");
            code = sspMapper.updateState(map);
            //添加驳回意见
            Map<String, Object> rejectMap = new HashMap<>(16);
            rejectMap.put("mainId", map.get("id"));
            rejectMap.put("opinion", map.get("opinion"));
            rejectMap.put("createUser", map.get("createUser"));
            codeA = sspMapper.saveSspAuditInfoReject(rejectMap);
        }
        return code + codeA;
    }

    @Override
    public Map<String, Object> querySspQualityMarkList(Map<String, Object> map) {
        Map<String,Object> resultMap = new HashMap<>();
        List<Map<String,Object>> list = sspMapper.querySspQualityMarkList(map);
        List<Map<String,Object>> list_my = sspMapper.querySspQualityMarkMyList(map);
        resultMap.put("list",list);
        resultMap.put("list_num",list != null?list.size():0);
        resultMap.put("list_my_num",list_my != null?list_my.size():0);
        return resultMap;
    }

    @Override
    public Map<String, Object> querySspQualityMarkMyList(Map<String, Object> map) {
        Map<String,Object> resultMap = new HashMap<>();
        List<Map<String,Object>> list = sspMapper.querySspQualityMarkList(map);
        List<Map<String,Object>> list_my = sspMapper.querySspQualityMarkMyList(map);
        resultMap.put("list",list_my);
        resultMap.put("list_num",list != null?list.size():0);
        resultMap.put("list_my_num",list_my != null?list_my.size():0);
        return resultMap;
    }

    @Override
    public Map<String, Object> querySspQualityMarkInfo(Map<String, Object> map) {
        Map<String,Object> data = sspMapper.querySspQualityMarkInfo(map);
        String[] arr;
        if(data.containsKey("before_imgs") && !"".equals(data.get("before_imgs"))){
            arr = data.get("before_imgs").toString().split(",");
            data.put("before_imgs",arr);
        }
        if(data.containsKey("after_imgs") && !"".equals(data.get("after_imgs"))){
            arr = data.get("after_imgs").toString().split(",");
            data.put("after_imgs",arr);
        }
        int approve_state = 0;//(0:不可审批;1:可审批)
        if(Integer.parseInt(data.get("state").toString()) == 0){//待审批
            String next_approve_login_name  = sspMapper.querySspQualityMarkApproveNextLoginName(map);
            String loginUser = map.containsKey("loginUser")?map.get("loginUser").toString():"";
            if(next_approve_login_name != null && next_approve_login_name.equals(loginUser)){
                approve_state = 1;
            }
        }
        data.put("approve_state",approve_state);
        return data;
    }

    @Override
    public Map<String, Object> updateSspQualityMarkApprove(Map<String, Object> map) {
        Map<String,Object> resultMap = new HashMap<>();
        if("2".equals(map.get("state").toString())){//驳回
            if(sspMapper.updateSspQualityMarkApproveState(map) == 1){
                if(sspMapper.updateSspQualityMarkState(map) == 1){
                    resultMap.put("code","200");
                    resultMap.put("msg","审批成功！");
                }
            }
        }else if("1".equals(map.get("state").toString())){//通过
            if(sspMapper.updateSspQualityMarkApproveState(map) == 1){
                if(sspMapper.querySspQualityMarkToBeApprovedNum(map) == 0){
                    if(sspMapper.updateSspQualityMarkState(map) == 1){
                        resultMap.put("code","200");
                        resultMap.put("msg","审批成功！");
                    }else{
                        resultMap.put("code","201");
                        resultMap.put("msg","审批失败！");
                    }
                }else{
                    resultMap.put("code","200");
                    resultMap.put("msg","审批成功！");
                }
            }else {
                resultMap.put("code","201");
                resultMap.put("msg","审批失败！");
            }
        }
        return resultMap;
    }

    @Override
    public List<Map<String, Object>> selectProjectTypeList(Map<String, Object> projectType) {
        return sspMapper.selectProjectTypeList(projectType);
    }

    @Override
    public List<ProcessName> selectProcessName(String isDel) {
        return sspMapper.selectProcessName(isDel);
    }

    @Override
    public Map<String, Object> querySmarkCode(String proId) {
        Map<String, Object> returnMap = new HashMap<>();
        List<Map<String, Object>> ponitCode = sspMapper.selectCodeFromSmark(proId);
        if(ponitCode.size() > 0 || ponitCode != null) {
            returnMap.put("code", "200");
            returnMap.put("msg", "查询成功");
            returnMap.put("ponitCode", ponitCode);
        } else {
            returnMap.put("code", "100");
            returnMap.put("msg", "请检查参数");
        }
        return returnMap;
    }
}
