
$(document).ready(function () {

    //大于 4M 时可分块上传，小于 4M 时直传,设置分块大小（分块上传时，支持断点续传）
    var BLOCK_SIZE = 4 * 1024 * 1024;

    //token
    var token;
    var bucket = "makalu-img";
    var domain = "http://fileimg.makalu.cc";
    //获取token的授权
    $.get("/mkl/sspManage/getToken", function(data){
        console.log("token" +"====================" +data);
        token = data;
    });


    //上传的文件信息
    var file;
    //上传对象
    var observable;
    //上传对象
    var subscription;


    //上传文件的名称
    var key;
    //配置信息
    var config = {
        //是否使用 cdn 加速域名：true 表示使用，默认为 false
        useCdnDomain: true,
        //是否禁用日志报告，为布尔值，默认为false
        disableStatisticsReport: false,
        //选择上传域名区域
        /*
         qiniu.region.z0: 代表华东区域
         qiniu.region.z1: 代表华北区域
         qiniu.region.z2: 代表华南区域
         qiniu.region.na0: 代表北美区域
         qiniu.region.as0: 代表东南亚区域
         */
        region: qiniu.region.z0
    };


    var putExtra ={
        //文件原文件名
        fname: "",
        //用来放置自定义变量
        params: {},
        //用来限定上传文件类型，指定null时自动判断文件类型 ["image/png", "image/jpeg", "image/gif"]
        mimeType: null
    };


    /**
     * selectFile1 上传
     * @type {{next(*=): void, error(*=): void, complete(*=): void}}
     */
    var observer1 = {
        next(res){
            console.log("当前已上传文件大小：" + res.total.loaded +"Byte");
            console.log("已上传文件百分比：" +res.total.percent.toFixed(2) + "%");
        },
        error(err){
            console.log(err);
            alert("上传出错,请修改文件名称后重试");
        },
        complete(res){
            console.log("文件上传成功");
            console.log(res);
            getFileQiniu1(res);
        }
    }

    /**
     * selectFile2 上传
     * @type {{next(*=): void, error(*=): void, complete(*=): void}}
     */
    var observer2 = {
        next(res){
            console.log("当前已上传文件大小：" + res.total.loaded +"Byte");
            console.log("已上传文件百分比：" +res.total.percent.toFixed(2) + "%");
        },
        error(err){
            console.log(err);
            alert("上传出错,请修改文件名称后重试!");
        },
        complete(res){
            console.log("文件上传成功!");
            getFileQiniu2(res);
        }
    }

    $("#selectFile1").change(function(){
        //获取当前选择的文件
        file = this.files[0];
        //当选择文件不为空时
        if (file) {
            //校验文件大小
            checkFileSize(file);
            //获取上传文件的名称
            let filename = file.name;
            let uuid = getuuid().replace(/-/g,"");
            // putExtra.fname = key.split(".")[0];
            putExtra.fname = uuid;
            // key = file.name;
            key = uuid + "." + filename.split(".")[1];
            //执行文件上传
            observable = qiniu.upload(file, key, token, putExtra, config);
            subscription = observable.subscribe(observer1);
        } else {
            alert("选择文件不能为空!")
        }
    })

    $("#selectFile2").change(function(){
        //获取当前选择的文件
        file = this.files[0];
        //当选择文件不为空时
        if (file) {
            //校验文件大小
            checkFileSize(file);
            //获取上传文件的名称
            let filename = file.name;
            let uuid = getuuid().replace(/-/g,"");
            // putExtra.fname = filename.split(".")[0];
            putExtra.fname = uuid;
            // key = filename;
            key = uuid + "." + filename.split(".")[1];
            //执行文件上传
            observable = qiniu.upload(file, key, token, putExtra, config);
            subscription = observable.subscribe(observer2);
        } else {
            alert("选择文件不能为空!")
        }
    })


    /**
     * 文件大小校验
     * @param file
     */
    function checkFileSize(file) {
        //计算分块大小
        let count = Math.ceil(file.size / BLOCK_SIZE);
        //文件大于限制禁止上传
        if (file.size >  10 * 1024 * 1024 * 1024) {
            console.log("不支持上传大于10G");
            return;
        }
        if(count > 1){
            console.log("大文件, 执行分块上传，支持断点续传!")
        } else {
            console.log("小文件上传!")
        }
    }

    function getuuid() {
        return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
            var r = Math.random() * 16 | 0,
                v = c == 'x' ? r : (r & 0x3 | 0x8);
            return v.toString(16);
        });
    }


})