package com.yanzhu.jh.project.service;

import java.util.List;
import com.yanzhu.jh.project.domain.SurProjectInsurance;

/**
 * 项目保险Service接口
 * 
 * @author JiangYuQi
 * @date 2023-08-09
 */
public interface ISurProjectInsuranceService 
{
    /**
     * 查询项目保险
     * 
     * @param projectId 项目保险主键
     * @return 项目保险
     */
    public SurProjectInsurance selectSurProjectInsuranceByProjectId(Long projectId);

    /**
     * 查询项目保险列表
     * 
     * @param surProjectInsurance 项目保险
     * @return 项目保险集合
     */
    public List<SurProjectInsurance> selectSurProjectInsuranceList(SurProjectInsurance surProjectInsurance);

    /**
     * 新增项目保险
     * 
     * @param surProjectInsurance 项目保险
     * @return 结果
     */
    public int insertSurProjectInsurance(SurProjectInsurance surProjectInsurance);

    /**
     * 修改项目保险
     * 
     * @param surProjectInsurance 项目保险
     * @return 结果
     */
    public int updateSurProjectInsurance(SurProjectInsurance surProjectInsurance);

    /**
     * 批量删除项目保险
     * 
     * @param projectIds 需要删除的项目保险主键集合
     * @return 结果
     */
    public int deleteSurProjectInsuranceByProjectIds(Long[] projectIds);

    /**
     * 删除项目保险信息
     * 
     * @param projectId 项目保险主键
     * @return 结果
     */
    public int deleteSurProjectInsuranceByProjectId(Long projectId);
}
