package com.yanzhu.jh.project.service;

import java.util.List;
import com.yanzhu.jh.project.domain.SurProjectSchedule;

/**
 * 项目进度Service接口
 * 
 * @author Jiangdu
 * @date 2023-07-29
 */
public interface ISurProjectScheduleService 
{
    /**
     * 查询项目进度
     * 
     * @param Id 项目进度主键
     * @return 项目进度
     */
    public SurProjectSchedule selectSurProjectScheduleById(Long id);

    /**
     * 查询项目进度列表
     * 
     * @param surProjectSchedule 项目进度
     * @return 项目进度集合
     */
    public List<SurProjectSchedule> selectSurProjectScheduleList(SurProjectSchedule surProjectSchedule);

    public SurProjectSchedule getProjectConstructionProgress(Long projectId);
    /**
     * 新增项目进度
     * 
     * @param surProjectSchedule 项目进度
     * @return 结果
     */
    public int insertSurProjectSchedule(SurProjectSchedule surProjectSchedule);

    /**
     * 修改项目进度
     * 
     * @param surProjectSchedule 项目进度
     * @return 结果
     */
    public int updateSurProjectSchedule(SurProjectSchedule surProjectSchedule);

    /**
     * 批量删除项目进度
     * 
     * @param ids 需要删除的项目进度主键集合
     * @return 结果
     */
    public int deleteSurProjectScheduleByIds(Long[] ids);

    /**
     * 删除项目进度信息
     * 
     * @param id 项目进度主键
     * @return 结果
     */
    public int deleteSurProjectScheduleById(Long id);
}
