package com.yanzhu.jh.project.service.impl;

import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.yanzhu.jh.project.mapper.SurProjectInsuranceMapper;
import com.yanzhu.jh.project.domain.SurProjectInsurance;
import com.yanzhu.jh.project.service.ISurProjectInsuranceService;
import com.ruoyi.common.utils.SecurityUtils;
/**
 * 项目保险Service业务层处理
 * 
 * @author JiangYuQi
 * @date 2023-08-09
 */
@Service
public class SurProjectInsuranceServiceImpl implements ISurProjectInsuranceService 
{
    @Autowired
    private SurProjectInsuranceMapper surProjectInsuranceMapper;

    /**
     * 查询项目保险
     * 
     * @param projectId 项目保险主键
     * @return 项目保险
     */
    @Override
    public SurProjectInsurance selectSurProjectInsuranceByProjectId(Long projectId)
    {
        return surProjectInsuranceMapper.selectSurProjectInsuranceByProjectId(projectId);
    }

    /**
     * 查询项目保险列表
     * 
     * @param surProjectInsurance 项目保险
     * @return 项目保险
     */
    @Override
    public List<SurProjectInsurance> selectSurProjectInsuranceList(SurProjectInsurance surProjectInsurance)
    {
        return surProjectInsuranceMapper.selectSurProjectInsuranceList(surProjectInsurance);
    }

    /**
     * 新增项目保险
     * 
     * @param surProjectInsurance 项目保险
     * @return 结果
     */
    @Override
    public int insertSurProjectInsurance(SurProjectInsurance surProjectInsurance)
    {
        return surProjectInsuranceMapper.insertSurProjectInsurance(surProjectInsurance);
    }

    /**
     * 修改项目保险
     * 
     * @param surProjectInsurance 项目保险
     * @return 结果
     */
    @Override
    public int updateSurProjectInsurance(SurProjectInsurance surProjectInsurance)
    {
        return surProjectInsuranceMapper.updateSurProjectInsurance(surProjectInsurance);
    }

    /**
     * 批量删除项目保险
     * 
     * @param projectIds 需要删除的项目保险主键
     * @return 结果
     */
    @Override
    public int deleteSurProjectInsuranceByProjectIds(Long[] projectIds)
    {
        return surProjectInsuranceMapper.deleteSurProjectInsuranceByProjectIds(projectIds);
    }

    /**
     * 删除项目保险信息
     * 
     * @param projectId 项目保险主键
     * @return 结果
     */
    @Override
    public int deleteSurProjectInsuranceByProjectId(Long projectId)
    {
        return surProjectInsuranceMapper.deleteSurProjectInsuranceByProjectId(projectId);
    }
}
