package com.yanzhu.jh.trouble.mapper;

import com.yanzhu.jh.trouble.domain.SmzSspProblemmodify;

import java.util.List;

/**
 * 质量整改Mapper接口
 * 
 * @author JiangYuQi
 * @date 2023-07-28
 */
public interface SmzSspProblemmodifyMapper 
{
    /**
     * 查询质量整改
     * 
     * @param id 质量整改主键
     * @return 质量整改
     */
    public SmzSspProblemmodify selectSmzSspProblemmodifyById(Long id);

    /**
     * 查询质量整改列表
     * 
     * @param smzSspProblemmodify 质量整改
     * @return 质量整改集合
     */
    public List<SmzSspProblemmodify> selectSmzSspProblemmodifyList(SmzSspProblemmodify smzSspProblemmodify);

    /**
     * 新增质量整改
     * 
     * @param smzSspProblemmodify 质量整改
     * @return 结果
     */
    public int insertSmzSspProblemmodify(SmzSspProblemmodify smzSspProblemmodify);

    /**
     * 修改质量整改
     * 
     * @param smzSspProblemmodify 质量整改
     * @return 结果
     */
    public int updateSmzSspProblemmodify(SmzSspProblemmodify smzSspProblemmodify);

    /**
     * 删除质量整改
     * 
     * @param id 质量整改主键
     * @return 结果
     */
    public int deleteSmzSspProblemmodifyById(Long id);

    /**
     * 批量删除质量整改
     * 
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteSmzSspProblemmodifyByIds(Long[] ids);

    public List<SmzSspProblemmodify> selectSummary(SmzSspProblemmodify smzSspProblemmodify);

    public List<SmzSspProblemmodify> selectSummaryByProject(SmzSspProblemmodify smzSspProblemmodify);
}
